// PROGRAM BY DESIGN: HOW TO DESIGN CLASSES (REACH_JAVA)
// copyright VIERA K. PROULX

/*
             +------+                
             | ABST |<--------------+
             +------+               |
             +------+               |
               / \                  |
               ---                  |
                |                   |
       ------------------           |
       |                |           |
  +----------+    +------------+    |
  | Leaf     |    | Node       |    |
  +----------+    +------------+    |
  | String s |    | String s   |    |
  +----------+    | ABST left  |-+  |
                  | ABST right |-+  |
                  +------------+ |  |
                                 |  |
                                 +--+

*/

// to represent a binary search tree
abstract class ABST {
}

// to represent a leaf in a binary search tree
class Leaf extends ABST {
  String s;

  Leaf(String s) {
    this.s = s;
  }
}

// to represent an internal node in a binary search tree
class Node extends ABST {
  String s;
  ABST left;
  ABST right;

  Node(String s, ABST left, ABST right) {
    this.s = s;
    this.left = left;
    this.right = right;
  }
}
