import tester.*;

// PROGRAM BY DESIGN: HOW TO DESIGN CLASSES (REACH_JAVA)
// copyright 2011 VIERA KRNANOVA PROULX
// ISSEP 2011 WORKSHOP

// Part 2: A simple class with methods
// File:   Book2.java

/*
+---------------+
| Book2         |
+---------------+
| String title  |
| String author |
| int year      |
+---------------+

*/

// to represent a book
public class Book2 {
  String title;
  String author;
  int year;

  Book2(String title, String author, int year) {
    this.title = title;
    this.author = author;
    this.year = year;
  }

/*
  // ** DRAFT TEMPLATE ** Edit as needed.
  ??? mmm() {
    ... this.title ...    -- String
    ... this.author ...   -- String
    ... this.year ...     -- int
  }
*/

  // was this book publisehd before year 2000?
  boolean before2000(){
    return this.year < 2000;
  }

  // was this book publisehd before the given year?
  boolean before(int year){
    return this.year < year;
  }

  // is this book older than the given book?
  boolean isOlderThan(Book2 that){

  /* TEMPLATE:
    ... this.title ...    -- String
    ... this.author ...   -- String
    ... this.year ...     -- int

    ... that.title ...    -- String
    ... that.author ...   -- String
    ... that.year ...     -- int
  */
    if (this.year < that.year)
      return true;
    else
      return false;
  }

  // produce the older of this and that given book
  Book2 olderBook(Book2 that){
    if (this.year < that.year)
      return this;
    else
      return that;
  }

  // produce a new edition of this book in the given year
  Book2 newEdition(int year){
    return new Book2(this.title, this.author, year);
  }
}

// examples of data and tests
class ExamplesBook2{
  ExamplesBook2() {}

  Book2 b1 = new Book2("RC", "DD", 1796);
  Book2 b2 = new Book2("LPP", "StEx", 1942);
  Book2 b3 = new Book2("HtDP", "FFFK", 2001);

  // test the method before2000
  boolean testBefore2000(Tester t){
	  return
	  t.checkExpect(this.b1.before2000(), true) &&
	  t.checkExpect(this.b3.before2000(), false);
  }

  // test the method before
  boolean testBefore(Tester t){
	  return
	  t.checkExpect(this.b1.before(1900), true) &&
	  t.checkExpect(this.b3.before(1900), false);
  }

  // test the method olderBook2
  boolean testOlderBook1(Tester t){
	  return
	  t.checkExpect(this.b1, this.b1.olderBook(this.b2)) &&
	  t.checkExpect(this.b1, this.b3.olderBook(this.b1));
  }

  // test the method newEdition
  boolean testNewEdition(Tester t){
	  return
	  t.checkExpect(this.b3.newEdition(2005), 
			        new Book2("HtDP", "FFFK", 2005));
  }
  
  // run the tests
  public static void main(String[] argv){
	  ExamplesBook2 eb2 = new ExamplesBook2();
	  Tester.runFullReport(eb2);
  }
}
