import tester.*;

// PROGRAM BY DESIGN: HOW TO DESIGN CLASSES (REACH_JAVA)
// copyright 2011 VIERA KRNANOVA PROULX
// ISSEP 2011 WORKSHOP


// Part 3: A class with containment
// File:   Book3.java


/*
+---------------+
| Book3         |
+---------------+
| String title  |    +-------------+
| Author author |--->| Author      |
| int year      |    +-------------+
+---------------+    | String name |
                     | int dob     |
                     +-------------+
*/

// to represent a book
public class Book3 {
  String title;
  Author author;
  int year;

  Book3(String title, Author author, int year) {
    this.title = title;
    this.author = author;
    this.year = year;
  }

/*
  // ** DRAFT TEMPLATE ** Edit as needed.
  ??? mmm() {
    ... this.title ...    -- String
    ... this.author ...   -- Author
    ... this.year ...     -- int

    ... this.author.mmm() ...
  }
*/

  // was this book written by the same author as the given book?
  boolean sameAuthor(Book3 that){
    return this.author.same(that.author);
  }
  
  // is the author of this book older than the author of the given book?
  boolean olderAuthor(Book3 that){
	  return this.author.olderThan(that.author);
  }
}


// to represent an author of a book
class Author {
  String name;
  int dob;

  Author(String name, int dob) {
    this.name = name;
    this.dob = dob;
  }

/*
  // ** DRAFT TEMPLATE ** Edit as needed.
  ??? mmm() {
    ... this.name ...  -- String
    ... this.dob ...   -- int
  }
*/

  // to determine whether this author is the same as the given author
  boolean same(Author that){
    return this.name.equals(that.name) &&
           this.dob == that.dob;
  }
  
  // is this author older than the given author?
  boolean olderThan(Author that){
	  return this.dob < that.dob;
  }
}

// examples of data and tests
class ExamplesBook3{
  ExamplesBook3() {}

  Author dd = new Author("DD", 1760);
  Author stex = new Author("StEx", 1900);
  Author mf = new Author("MF", 1958);
  Author mf2 = new Author("MF", 1958);

  Book3 b1 = new Book3("RC", dd, 1796);
  Book3 b2 = new Book3("LPP", stex, 1942);
  Book3 b3 = new Book3("HtDP", mf, 2001);
  Book3 b4 = new Book3("LL", mf2, 1989);

  // test the method same in the class Author
  boolean testSame(Tester t){
	  return
	  t.checkExpect(this.dd.same(this.mf), false) &&
	  t.checkExpect(this.mf.same(this.mf2), true);
  }

  // test the method sameAuthor in the class Book3
  boolean testSameAuthor(Tester t){
	  return
	  t.checkExpect(this.b1.sameAuthor(this.b2), false) &&
	  t.checkExpect(this.b3.sameAuthor(this.b4), true);
  }

  // test the method olderThan in the class Author
  boolean testolderThan(Tester t){
	  return
	  t.checkExpect(this.dd.olderThan(this.mf), true) &&
	  t.checkExpect(this.mf.olderThan(this.stex), false);
  }

  // test the method olderAuthor in the class Book3
  boolean testOlderAuthor(Tester t){
	  return
	  t.checkExpect(this.b1.olderAuthor(this.b2), true) &&
	  t.checkExpect(this.b3.olderAuthor(this.b1), false);
  }
  
  // run the tests
  public static void main(String[] argv){
	  ExamplesBook3 eb3 = new ExamplesBook3();
	  Tester.runFullReport(eb3);
  }
}