import tester.*;

// PROGRAM BY DESIGN: HOW TO DESIGN CLASSES (REACH_JAVA)
// copyright 2011 VIERA KRNANOVA PROULX
// ISSEP 2011 WORKSHOP

// Part 5: A self-referential union of classes: representing lists
// File:   Book5.java

/*
            +---------+                
            | ILoBook |<--------------+
            +---------+               |
            +---------+               |
                / \                   |
                ---                   |
                 |                    |
       -------------------            |
       |                 |            |
  +----------+    +--------------+    |
  | MTLoBook |    | ConsLoBook   |    |
  +----------+    +--------------+    |
  +----------+  +-| Book first   |    |
                | | ILoBook rest |----+
                | +--------------+ 
                |
                v
       +---------------+
       | Book          |
       +---------------+
       | String title  |
       | String author |
       | int year      |
       +---------------+
*/

// to represent a list of books
interface ILoBook { }

// to represent an empty list of books
class MTLoBook implements ILoBook {

  MTLoBook() {
  }
}

// to represent a nonempty list of Books
class ConsLoBook implements ILoBook {
  Book5 first;
  ILoBook rest;

  ConsLoBook(Book5 first, ILoBook rest) {
    this.first = first;
    this.rest = rest;
  }
}

// to represent a book
public class Book5 {
  String title;
  String author;
  int year;

  Book5(String title, String author, int year) {
    this.title = title;
    this.author = author;
    this.year = year;
  }
}

// examples of data and tests
class ExamplesBook5{
  ExamplesBook5() {}

  Book5 b1 = new Book5("RC", "DD", 1796);
  Book5 b2 = new Book5("LPP", "StEx", 1942);
  Book5 b3 = new Book5("HtDP", "FFFK", 2001);

  ILoBook mtbooks = new MTLoBook();
  ILoBook books1 = new ConsLoBook(this.b1, 
                   new ConsLoBook(this.b2, 
                   this.mtbooks));
  ILoBook books2 = new ConsLoBook(this.b3, this.books1);

  
  // run the tests
  public static void main(String[] argv){
	  ExamplesBook5 eb5 = new ExamplesBook5();
	  Tester.runFullReport(eb5);
  }
}
